#include "environment.h"

#include "defs.h"

Environment::Environment(const QApplication& app)
{
	// INITIALIZE THE INSTALL DIRECTORY
	QDir				dir(app.applicationDirPath());

	// On most platforms, I *believe* the app directory is the
	// actual app directory.
	mInstallPath = dir.absolutePath();

	// On mac, I might be stored in a bundle.
#ifdef Q_WS_MAC
	while (true) {
		QFileInfo		fi(dir.absolutePath());
		if (fi.isBundle()) {
			// Get the directory containing me, which is two deep
			if (dir.cdUp() && dir.cdUp()) mInstallPath = dir.absolutePath();
			break;
		}
		if (!dir.cdUp()) break;
	}
#endif

	// One last thing, this might be the build directory.
	dir.setPath(mInstallPath);
	if (dir.dirName() == APP_INSTALL_DIR + "-build-desktop") {
		if (dir.cdUp() && dir.cd(APP_INSTALL_DIR) && dir.cd("install")) {
			mInstallPath = dir.absolutePath();
		}
	}
}

QString Environment::getInstallPath() const
{
	return mInstallPath;
}

QString Environment::getInstallPath(const QString& sub) const
{
	if (sub.length() < 1) return mInstallPath;
	return mInstallPath + QDir::separator() + sub;
}

