#ifndef WIN_H
#define WIN_H

#include <QWidget>

#include "environment.h"
#include "ui/look.h"
#include "ui/navigation.h"

class QLabel;
class QLineEdit;
class QTextEdit;
class ActiveProject;
class ArcList;
class ColorSrcList;
class RenderView;
class StripView;

/* WIN
 * The top-level window for the application
 ******************************************************************/
class Win : public QWidget
{
	Q_OBJECT

public:
	Win(const Environment&, const ArcList&, const ColorSrcList&,
		ActiveProject&, QWidget *parent = 0);

signals:

public slots:
	void					onAddFx(const QPoint pos);
	void					onRemoveFx(const int fxId);
	void					onSelectFx(const int fxId);

	void					onCommand(const QString);
	void					onRequestLoadProject();
	void					onRequestSaveProject();

private:
	class NewFxUi;
	class FxMenu;

	const Environment&		mEnv;
	const ArcList&			mArcs;
	const ColorSrcList&		mClrs;
	ActiveProject&			mPrj;
	Look					mLook;
	// Current layer
	int						mLayer;

	Navigation				mNavigation;

	RenderView*				mRenderView;
	StripView*				mStrip0;
	StripView*				mStrip1;
	// The row of project settings at the bottom of the window
	StripView*				mSettingsStrip;
};

#endif // WIN_H
