#ifndef ARC_CHAIN_H
#define ARC_CHAIN_H

#include <QList>
#include "engine/arc.h"

namespace arc {

/* CHAIN
 * A series of arcs, multipled together
 ******************************************************************/
class Chain : public Arc
			, public arc::Reader::Target
{
public:
	Chain();
	Chain(const Chain&);
	virtual ~Chain();

	virtual Chain*			copy() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual int				forEach(arc::Visitor&);

	virtual void			work(WorkParams&, float* row);

	void					append(Arc*);

	// IO
	virtual void			writeJsonObject(json::Writer&) const;
	virtual void			startArray(json::Stack&, const QString&);
	virtual void			parseArc(Arc*);

#ifdef QT_DEBUG
	virtual void			printTree(const int tabs) const;
#endif

private:
	QList<Arc*>				mArc;
};

} // arc

#endif // ARC_CHAIN_H
