#ifndef ARCVISITORS_H
#define ARCVISITORS_H

/* A collection of useful visitors for arcs.
 ******************************************************************/

#include "engine/arcdefs.h"

namespace arc {

/* LAST-ID
 * Get the largest current ID value.
 ******************************************************************/
class LastId : public Visitor
{
public:
	LastId();

	int				mLastId;

	virtual int		visit(Arc&);
};

/* FILL-ID
 * Set any invalid IDs to the next valid.
 ******************************************************************/
class FillId : public Visitor
{
public:
	FillId(const int nextId);

	int				mNextId;

	virtual int		visit(Arc&);
};

} // namespace arc

#endif // ARCVISITORS_H
