#ifndef NOISE_H
#define NOISE_H

#include "engine/arc.h"
#include "math/rnd/linearcongruence.h"

namespace arc {

/* NOISE
 * Basic noise, currently linear congruence.
 ******************************************************************/
class Noise : public Arc
{
public:
	Noise(const float amount = 0.1f);
	Noise(const Noise&);

	virtual Noise*			copy() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(WorkParams&, float* row);

	// IO
	virtual void			writeJsonObject(json::Writer&) const;
	virtual void			jsonFloat(json::Stack&, const QString&, const float);

#ifdef QT_DEBUG
	virtual void			printTree(const int tabs) const;
#endif

private:
	float					mAmt;
	LinearCongruence		mLin;
};

} // arc

#endif // NOISE_H
