#ifndef POW_H
#define POW_H

#include "engine/arc.h"

namespace arc {

/* POW
 * Power operation.
 ******************************************************************/
class Pow : public Arc
{
public:
	Pow(const float amt = 0.5f);
	Pow(const Pow&);

	virtual Pow*			copy() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(WorkParams&, float* row);

	// IO
	virtual void			writeJsonObject(json::Writer&) const;
	virtual void			jsonFloat(json::Stack&, const QString&, const float);

#ifdef QT_DEBUG
	virtual void			printTree(const int tabs) const;
#endif

private:
	float					mAmt;
};

} // arc

#endif // POW_H
