#ifndef SINE_H
#define SINE_H

#include "engine/arc.h"

namespace arc {

/* SINE
 * A sine wave arc
 ******************************************************************/
class Sine : public Arc
{
public:
	Sine(const float period = 1, const float phase = 0, const bool bipolar = true);
	Sine(const Sine&);

	virtual Sine*			copy() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(WorkParams&, float* row);

	// IO
	virtual void			writeJsonObject(json::Writer&) const;
	virtual void			jsonFloat(json::Stack&, const QString&, const float);

#ifdef QT_DEBUG
	virtual void			printTree(const int tabs) const;
#endif

private:
	float					mPeriod;
	float					mPhase;
	bool					mBipolar;
};

} // arc

#endif // SINE_H
