#ifndef ARCRENDER_H
#define ARCRENDER_H

#include <QSize>

#include "engine/arcdefs.h"
#include "compositing/mask.h"

class QPixmap;
class ArcHead;

/* ARC-RENDER
 * A support class for rendering arcs.
 ******************************************************************/
class ArcRender
{
public:
	ArcRender();

	QPixmap*				onRender(ArcHead&, const QSize&);
	bool					onRender(ArcHead&, QPixmap&);

private:
	arc::WorkParams			mArcP;
	Mask					mRowV, mRowMask;

	QSize					mSize;

	bool					makeSource(const QSize&);
};

#endif // ARCRENDER_H
