#include "byteset.h"

#include <QDebug>

#include <stdlib.h>

/* BYTE-SET
 ******************************************************************/
ByteSet::ByteSet()
	: mData(NULL)
	, mSize(0)
{
}

ByteSet::~ByteSet()
{
}

qint8 ByteSet::getAt(const int idx, const qint8 error) const
{
	if (idx < 0 || idx >= mSize) return error;
	return mData[idx];
}

bool ByteSet::setAt(const int idx, const qint8 value)
{
	if (idx < 0) return false;
	if (idx >= mSize) {
		const int			newSize = idx+8;
		qint8*				newData = mContainer.get(newSize);
		if (newData == NULL) return false;
		// This is questionable -- there's really no reason
		// to initialize the values to anything, and it's probably
		// reasonable to leave that up to the client
		for (int k=mSize; k<newSize; k++) newData[k] = 0;
		mData = newData;
		mSize = newSize;
	}
	mData[idx] = value;
	return true;
}
