#ifndef BYTESET_HXX
#define BYTESET_HXX

#include <QtGlobal>
#include "collections/recyclearray.h"

/* BYTE-SET
 * A simple, efficient array of bytes.
 ******************************************************************/
class ByteSet
{
public:
	ByteSet();
	virtual ~ByteSet();

	// Answer the value at the index, returning error if out of bounds.
	qint8					getAt(const int idx, const qint8 error = -1) const;
	// Set the value at the index, growing if necessary.
	bool					setAt(const int idx, const qint8 value);

private:
	RecycleArray<qint8>		mContainer;
	qint8*					mData;
	int						mSize;
};

#endif // BYTESET_HXX
