#ifndef COLORSRC1_H
#define COLORSRC1_H

#include "engine/colorsrc.h"

// Constants
extern const QString&		COLOR_SRC_1_KEY_SZ;

/* COLOR-SRC-1
 * A ColorSrc on a single color (i.e. a constant).
 ******************************************************************/
class ColorSrc1 : public ColorSrc
{
public:
	ColorSrc1(const int r, const int g, const int b, const int a);

	virtual ColorSrc1*		copy() const;
	virtual void			get(const float v, color_f& output) const;
	virtual void			scaleAlpha(const float);

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	// IO
	virtual void			writeJsonObject(json::Writer&) const;
	virtual void			jsonString(json::Stack&, const QString&, const QString&);

private:
	ColorSrc1(const ColorSrc1&);

	// The color in standard unmatted values.
	color_f					mClr;
	// The color, but alpha premultiplied
	color_f					mClr_Pm;

	void					premultiply();
};

#endif // COLORSRC1_H
