#ifndef COLORSRCLIST_H
#define COLORSRCLIST_H

#include <QString>
#include "collections/recyclelist.h"
#include "engine/colorsrchead.h"

/* COLOR-SRC-LIST
 * Store a collection of color sources.
 ******************************************************************/
class ColorSrcList
{
public:
	class Visitor;
	static void					addDefaults(ColorSrcList&);

public:
	ColorSrcList();
	~ColorSrcList();

	bool						find(ColorSrcHead&, const ColorSrcMatch&) const;

	void						forEach(Visitor&) const;

	// XXX Ugly hack to quickly get access to a specific src.
	// Ultimately we won't want this, it will be replaced by accessing via keys.
	const ColorSrcHead*			getAt(int idx) const;

private:
	RecycleList<ColorSrcHead*>	mList;

	/* VISITOR
	 ******************************************************************/
public:
	class Visitor {
	public:
		virtual ~Visitor()	{ }

		// Answer fx::CONTINUE, etc.
		virtual int			visit(const ColorSrcHead&) = 0;

	protected:
		Visitor()			{ }
	};
};

/* CONSTANTS
 ******************************************************************/
extern const char*				COLOR_SRC_DEFAULT_SOLO;
extern const char*				COLOR_SRC_DEFAULT_DUO;

#endif // COLORSRCLIST_H
