#include "workmasks.h"

#include "assert.h"

/* WORK-MASKS
 ******************************************************************/
WorkMasks::WorkMasks(const int size)
	: mSize(size)
{
	assert(mSize <= LIMIT);
}

bool WorkMasks::start(fx::WorkArgs& a, const int maskSize)
{
	if (mSize < 1) return true;
	if (mSize > LIMIT) return false;

	bool			failed = false;
	for (int k=0; k<mSize; k++) {
		mMask[k] = a.acquireMask(maskSize);
		if (mMask[k] == NULL || (d[k] = mMask[k]->get(maskSize)) == NULL)
			failed = true;
	}
	if (failed) {
		stop(a);
		return false;
	}
	return true;
}

void WorkMasks::stop(fx::WorkArgs& a)
{
	for (int k=0; k<mSize; k++) {
		if (mMask[k] != NULL) a.releaseMask(mMask[k]);
		mMask[k] = NULL;
		d[k] = NULL;
	}

}
