#ifndef WORKMASKS_H
#define WORKMASKS_H

#include "engine/fxdefs.h"

/* WORK-MASKS
 * This convenience class manages a series of buffers from
 * fx::WorkArgs.  It doesn't own the buffers, but acquires
 * them from the args and releases them when finished.
 ******************************************************************/
class WorkMasks
{
public:
	static const int	LIMIT = 4;
public:
	explicit WorkMasks(const int size);

	// It's simpler just to hardcode these for now, but if
	// I need to I can bump the limit or make it dynamic
	float*				d[LIMIT];

	bool				start(fx::WorkArgs&, const int maskSize);
	void				stop(fx::WorkArgs&);

private:
	WorkMasks(const WorkMasks&);
	WorkMasks&			operator=(const WorkMasks&);

	Mask*				mMask[LIMIT];
	const int			mSize;
};

#endif // WORKMASKS_H
