#include "arc.h"

#include "engine/fxdefs.h"
#include "math/geo.h"

/* ARC
 ******************************************************************/
Arc::Arc()
{
}

Arc::Arc(const Arc& o)
	: param::Parent(o)
	, json::Reader(o)
{
}

Arc::~Arc()
{
}

int Arc::forEach(arc::Visitor& v)
{
	v.visit(*this);
	return arc::CONTINUE;
}

/* IO
 ******************************************************************/
void Arc::jsonFloat(json::Stack&, const QString& k, const float v)
{
	if (k == fx::ID_SZ) mId = geo::iroundf(v);
}

void Arc::writeJsonHeader(json::Writer& w, const QString& key) const
{
	w.beginObject();
	w.key(arc::ARC_SZ);
	w.stringValue(key);
	w.key(fx::ID_SZ);
	w.intValue(mId);
}

void Arc::writeJsonFooter(json::Writer& w) const
{
	w.endObject();
}
