#include "arcmod.h"

#include "engine/arc.h"

using namespace arc;

/* ARC::MOD-SRC
 ******************************************************************/
ModSrc::ModSrc()
	: mState(0)
{
}

void ModSrc::setIsOn(const bool b)
{
	if (b) mState |= STATE_ON;
	else mState &= ~STATE_ON;
}

float* ModSrc::row(const int size)
{
	if ((mState&STATE_ON) == 0) return NULL;
	return mRow.get(size);
}

/* ARC::MOD-LINK
 ******************************************************************/
ModLink::ModLink()
	: mFlags(0)
	, mSrc(0)
	, mDstArc(-1)
{
}

ModLink::ModLink(const ModLink& o)
	: mFlags(o.mFlags)
	, mSrc(o.mSrc)
	, mDstArc(o.mDstArc)
	, mDstParam(o.mDstParam)
	, mR(o.mR)
{
}

ModLink::ModLink(	const int src, const int dstArc, const int dstParam,
					const float min, const float max)
	: mFlags(RANGE_ON_F)
	, mSrc(src)
	, mDstArc(dstArc)
	, mDstParam(dstParam)
	, mR(min, max)
{
}

ModLink::ModLink(const int src, const int dstArc, const int dstParam)
	: mFlags(0)
	, mSrc(src)
	, mDstArc(dstArc)
	, mDstParam(dstParam)
{
}

void ModLink::operator=(const ModLink& o)
{
	if (this != &o) {
		mFlags = o.mFlags;
		mSrc = o.mSrc;
		mDstArc = o.mDstArc;
		mDstParam = o.mDstParam;
		mR = o.mR;
	}
}

/* ARC::MOD-TABLE
 ******************************************************************/
ModTable::ModTable()
{
}

void ModTable::setTo(const ModTable& o)
{
	if (this != &o) {
		mLink = o.mLink;
	}
}
