#ifndef COLORSRC_H
#define COLORSRC_H

#include "engine/colorf.h"
#include "engine/parent.h"
#include "io/json.h"
#include "param/paramlist.h"

/* COLOR-SRC
 * Object that translates a scaled value (0-1) into a color.
 ******************************************************************/
class ColorSrc : public param::Parent
				, public json::Reader
{
public:
	virtual ~ColorSrc();

	virtual ColorSrc*		copy() const = 0;

	// Get the colour at the given value (0-1).
	virtual void			get(const float v, color_f& output) const = 0;

	// Scale the alpha of all components.
	virtual void			scaleAlpha(const float) = 0;

	virtual param::Parent*	findParent(param::UrlIterator&);

	// IO
	virtual void			writeJsonObject(json::Writer&) const = 0;

protected:
	ColorSrc();
	ColorSrc(const ColorSrc&);
};

#endif // COLORSRC_H
