#include "engineparam.h"

using namespace param;

static const QString	FRAME_SZ_S("frame");
const QString&			param::FRAME_SZ = FRAME_SZ_S;

static const QString	LEFT_SZ_S("left");
const QString&			param::LEFT_SZ = LEFT_SZ_S;

static const QString	TOP_SZ_S("top");
const QString&			param::TOP_SZ = TOP_SZ_S;

static const QString	RIGHT_SZ_S("right");
const QString&			param::RIGHT_SZ = RIGHT_SZ_S;

static const QString	BOTTOM_SZ_S("bottom");
const QString&			param::BOTTOM_SZ = BOTTOM_SZ_S;

const float				param::valueFromFlag(const int v, const int flagBit)
{
	return ((v&flagBit) == 0) ? 0 : 1;
}

const int				param::flagFromValue(const float v, const int flagBit)
{
	return (isExpanded(v)) ? flagBit : 0;
}

const bool				param::isExpanded(const float v)
{
	return (v >= 0.5f);
}

/* PARAM::SET-ARGS
 ******************************************************************/
SetArgs::SetArgs()
	: mV(0)
	, mChanged(false)
{
}

SetArgs::SetArgs(const SetArgs& o)
{
	*this = o;
}

void SetArgs::operator=(const SetArgs& o)
{
	if (this != &o) {
		mV = o.mV;
		mStr = o.mStr;
		mArc.setTo(o.mArc);
		mClr = o.mClr;
		mChanged = o.mChanged;
	}
}

void SetArgs::clear()
{
	*this = SetArgs();
}

void SetArgs::readFrom(const Param& p)
{
	mV = p.mFV;
	mStr = p.mSV;
}

void SetArgs::writeTo(Param& p) const
{
	p.mFV = mV;
	p.mSV = mStr;
}
