#ifndef FXIO_H
#define FXIO_H

#include "io/json_reader.h"

class Fx;

namespace fx {

/* FX::READER
 * A generic class clients can instantiate to read in FX's.
 ******************************************************************/
class Reader : public json::Reader
{
// Clients need to supply a target for all my FX reading efforts.
public:
	class Target {
	public:
		virtual ~Target() { }

		virtual void	parseFx(Fx*) = 0;

	protected:
		Target() { }
		Target(const Target&) { }
	};

public:
	explicit Reader(Target&);

	virtual void		jsonString(json::Stack&, const QString&, const QString&);
	virtual void		jsonPop();

private:
	Target&				mT;
};

} // namespace fx

#endif // FXIO_H
