#include "fxui.h"

#include <QPainter>
#include "ui/look.h"

/* PARENT
 *******************************/
FxUi::Parent::Parent() { }
FxUi::Parent::~Parent() { }

/* MOUSE-ARGS
 *******************************/
FxUi:: mouse_args::mouse_args()
	: mEvent(NULL)
	, mEntry(NULL)
	, mNeedsUpdate(false)
{
}

/* PAINT-ARGS
 *******************************/
FxUi:: paint_args::paint_args()
	: mPainter(NULL)
	, mLook(NULL)
{
}

/* ENTRY
 *******************************/
FxUi::Entry::Entry() { }
FxUi::Entry::~Entry() { }

void FxUi::Entry::onPaintBg(paint_args& pa)
{
	QPainter&			painter = *pa.mPainter;
	const Look&			look = *pa.mLook;
	const QRect&		frame = pa.mFrame;
	const int			f = flags();

	painter.setRenderHint(QPainter::Antialiasing);

	// Panel background
	painter.setPen(Qt::NoPen);
	painter.setBrush(look.mParamBgB);
	// Right now do this the easy way -- assume both sides are
	// closed, fill in if not.
	painter.drawRoundedRect(frame, look.mRound, look.mRound);
	if ((f&CONNECT_LEFT) != 0) painter.drawRect(frame.left(), frame.top(), look.mRound, frame.height());
	if ((f&CONNECT_RIGHT) != 0) painter.drawRect(frame.right()-look.mRound, frame.top(), look.mRound+1, frame.height());
}

/* CREATE
 *******************************/
FxUi::Create::Create(	const Environment& env, Context& prj,
						const ArcList& arcs, const ColorSrcList& clrs,
						const int mode)
	: mEnv(env)
	, mPrj(prj)
	, mArcs(arcs)
	, mClrs(clrs)
	, mMode(mode)
{
}

/* FX-UI
 *******************************/
FxUi::FxUi()
	: mParent(NULL)
{
}

FxUi::~FxUi()
{
}

void FxUi::setParent(Parent* p, const Look&)
{
	mParent = p;
}
