#include "parent.h"

using namespace param;

/* PARAM::PARENT static
 ******************************************************************/
void Parent::makeUrl(const Parent* p, Url& url)
{
	while (p != NULL) {
		url.prepend(p->getId());
		p = p->getParent();
	}
}

/* PARAM::PARENT
 ******************************************************************/
Parent::Parent()
	: mParent(NULL)
	, mId(-1)
{
}

Parent::Parent(const Parent& o)
	// Anyone who copies me would need to reconstruct the hierarchy.
	// Taking the parent from another tree would be bad.
	: mParent(NULL)
	, mId(o.mId)
{
}

Parent::~Parent()
{
}

void Parent::setParent(Parent* p)
{
	mParent = p;
}

bool Parent::setFlag(const int, const bool)
{
	return false;
}
