#ifndef BEVEL_EXTRUDE_H
#define BEVEL_EXTRUDE_H

#include "math/mathutils.h"
#include "math/poly/polygonlist.h"

namespace bevel {
class SourceList;

/* BEVEL::EXTRUDE.  Extrude a 2D polygon into 3D triangles.
 ******************************************************************/
class Extrude
{
public:
	Extrude();

	bool			on(const Polygon& src, const float depth, SourceList& out);

private:
	Point3			mMid, mGap0, mGap1;
	math::Order		mOrder;

	void			extrudePoints(	const Point3& b, const Point3& c, const float depth,
									Point3& out1, Point3& out2) const;
	void			fillGaps(	const Point3& prv, const Point3& cur, const Point3& nxt,
								const Point3& prvP3, const Point3& p1,
								const float depth,
								PolygonList& out);
	void			fillGaps(	const Point3& prv, const Point3& cur, const Point3& nxt,
								const Point3& prvP3, const Point3& p1,
								const float depth, SourceList& out);
	// A convenience for adding a new polygon (can be a tri or quad) to the output.
	void			add(const Point3*, const Point3*, const Point3*, const Point3*,
						PolygonList& out);
};

} // namespace bevel

#endif // BEVEL_EXTRUDE_H
