#ifndef COLORBROWSER_H
#define COLORBROWSER_H

#include "engine/fxuidefs.h"
#include "param/param.h"

class ColorSrcList;
class Context;

/* COLOR-BROWSER.  A model for selecting an item from the color src
 * list and setting it on a param.
 ******************************************************************/
class ColorBrowser : public fxui::BrowserModel
{
public:
	ColorBrowser(	Context&, const ColorSrcList&,
					const Param& p, const QSize& iconSize);
	virtual ~ColorBrowser();

	virtual int				size() const;
	virtual QSize			iconSize() const;

	virtual const QPixmap*	at(const int idx);

	virtual int				getIndex() const;
	virtual void			setIndex(const int idx);

private:
	class Render;
	ColorBrowser(const ColorBrowser&);

	Context&				mPrj;
	const ColorSrcList&		mClrs;
	param::Url				mUrl;
	const QSize				mIconSize;
	QList<QPixmap*>			mE;
	int						mIdx;
};

#endif // COLORBROWSER_H
