#include "json_copier.h"

#include <QDebug>
#include "io/json_parser.h"

using namespace json;

/* JSON::COPIER
 ******************************************************************/
Copier::Copier()
{
	mBuffer.open(QIODevice::ReadWrite);
}

Copier::~Copier()
{
	mBuffer.close();
}

bool Copier::from(const json::Writer::Client& c)
{
	json::Writer		w(&mBuffer);
	c.writeJson(w);
	return w.getError() >= Writer::OK;
}

bool Copier::to(json::Reader& r)
{
	json::Parser		p;
	mBuffer.seek(0);
	return p.parse(&mBuffer, &r);
}

