#ifndef SVGREADER_H
#define SVGREADER_H

#include <QtXml>
#include <QPainterPath>

#include "svgcmd.h"

class SvgReader
{
public:
    SvgReader();

	bool load(const QString& filename, QPainterPath* path);

private:

	class Handler : public QXmlDefaultHandler
	{
	public:
		Handler();

		QPainterPath				mPath;

		bool startElement(const QString & namespaceURI, const QString & localName, const QString & qName, const QXmlAttributes & atts );

	private:
		typedef QXmlDefaultHandler	inherited;
		QPointF						mLastPt;

		QString						mBuf;

		SvgCmdC						mCmdC;
		SvgCmdL						mCmdL;
		SvgCmdM						mCmdM;

		void addPath(const QString& d);
		SvgCmd* startCmd(SvgCmd* prev, SvgCmd* next, const bool isRelative);
		void flushBuffer(SvgCmd* cmd);
	};
};

#endif // SVGREADER_H
