#include "intersection.h"

using namespace math;

/* INTERSECTION
 ******************************************************************/
Intersection::Intersection()
{
	clear();
}

void Intersection::clear() {
	for (int k=0; k<SIZE; k++) {
		mA[k] = NULL;
		mB[k] = NULL;
	}
}

void Intersection::set(	const Intersection& o)
{
	if (this != &o) {
		mPt = o.mPt;
		for (int k=0; k<SIZE; k++) {
			mA[k] = o.mA[k];
			mB[k] = o.mB[k];
		}
		mSortOrigin = NULL;
	}
}

void Intersection::set(	const Point3& pt,
						const Point3& a0, const Point3& a1,
						const Point3& b0, const Point3& b1)
{
	mPt = pt;
	mA[0] = &a0;
	mA[1] = &a1;
	mB[0] = &b0;
	mB[1] = &b1;
	mSortOrigin = NULL;
}
