#ifndef INTERSECTION_H
#define INTERSECTION_H

#include "math/primitives/point3.h"

namespace math {

/* INTERSECTION
 * Store a single intersection, which means its point
 * and the segments that created it.  I own the point,
 * but not the segment points.
 ******************************************************************/
class Intersection
{
public:
	static const int	SIZE = 2;

	Point3				mPt;
	const Point3*		mA[SIZE];
	const Point3*		mB[SIZE];

	// Only valid during list sorting
	const Point3*		mSortOrigin;

public:
    Intersection();

	void				clear();
	void				set(const Intersection&);
	void				set(const Point3& pt,
							const Point3& a0, const Point3& a1,
							const Point3& b0, const Point3& b1);
};

} // namespace math

#endif // INTERSECTION_H
