#include "polygonlist.h"

/* POLYGON-LIST
 ******************************************************************/
class PolyFactory : public ManagedFactory<Polygon*>
{
public:
	virtual Polygon*	newObject() const {
		Polygon*		ans = new Polygon();
		if (ans == NULL) throw std::exception();
		return ans;
	}

	virtual void		deleteObject(Polygon* p) const { delete p; }
	virtual void		initializeObject(Polygon* p) const { if (p != NULL) p->clear(); }
	virtual void		setObject(Polygon* dst, Polygon* src) const { if (src != NULL) dst->set(*src); }
};
static PolyFactory		POLY_FACTORY;

PolygonList::PolygonList()
	: inherited(POLY_FACTORY)
{
}
