#include "step.h"

using namespace math;

/* STEP
 ******************************************************************/
Step::Step()
{
}

void Step::set(const Point3& pt)
{
	mPt = &pt;
	mAlignment = GOOD;
	mIntersection = NULL;
}

void Step::set(const Intersection& inter)
{
	mPt = &(inter.mPt);
	mAlignment = NEUTRAL;
	mIntersection = &inter;
}

bool Step::isIntersection() const
{
	return mIntersection != NULL;
}

QDebug& math::operator<<(QDebug& d, const Step& o)
{
	if (o.mPt != NULL) (d << *(o.mPt)).nospace();
	(d << " align=").nospace();
	(d << o.mAlignment).nospace();
	if (o.mIntersection != NULL) {
		(d << " intersection=").nospace();
		(d << o.mIntersection->mPt).nospace();
	}
	return d;
}
