#include "plane.h"

#include "polygon.h"

/* PLANE
 ******************************************************************/
Plane::Plane()
{
}

void Plane::from(const Point3& a, const Point3& b, const Point3& c)
{
	mPt.set(a);

	// get triangle edge vectors and plane normal
	Point3			u, v;
	u = b - a;
	v = c - a;
	mN.asCross3(u, v);
}

bool Plane::from(const Polygon& p)
{
	const qint32		size = p.getSize();
	const Point3*		pts = p.getPoints();
	if (size < 3) return false;
	const Point3		&a = pts[0], &b = pts[1], &c = pts[2];

	mPt.set(a);

	// get triangle edge vectors and plane normal
	Point3				u, v;
	u.asSub(b, a);
	v.asSub(c, a);
	mN.asCross3(u, v);
	return true;
}
