#ifndef SEGMENT3_H
#define SEGMENT3_H

#include <QRectF>
#include "point3.h"

class QPointF;

/* SEGMENT-3
 * Line segment, 3D.
 ******************************************************************/
class Segment3
{
public:
    Segment3();
	Segment3(const QPointF& a, const QPointF& b);

	static const int	SIZE = 2;

	Point3				mPt[SIZE];

	void				set(const Segment3&);
	void				set(const Point3& a, const Point3& b);
	void				set(const QPointF& a, const QPointF& b);

	double				distanceTo(const Point3& pt, Point3* nearest = NULL) const;
	double				distanceToSquared(const Point3& pt, Point3* nearest = NULL) const;

	void				reverse();

	void				getFrame(QRectF&) const;
};

QDebug& operator<<(QDebug&, const Segment3&);

#endif // SEGMENT3_H
