#include "linearcongruence.h"

#include <stdlib.h>
#include <time.h>

/* LINEAR-CONGRUENCE
 ******************************************************************/
LinearCongruence::LinearCongruence(	const qint32 seed, const qint32 a,
									const qint32 c, const qint32 m)
		: mA(a)
		, mC(c)
		, mM(m)
{
	Seed(seed);
}

LinearCongruence::LinearCongruence(const LinearCongruence& o)
			: mSeed(o.mSeed)
			, mA(o.mA)
			, mC(o.mC)
			, mM(o.mM)
{
}

LinearCongruence& LinearCongruence::operator=(const LinearCongruence& o)
{
	if (this != &o) {
		mSeed = o.mSeed;
	}
	return *this;
}

void LinearCongruence::Seed(const qint32 seed)
{
	if (seed < 0) {
		srand(time(NULL));
		mSeed = rand();
	} else mSeed = seed;
}
