#include "lineiscolinear.h"

#include "math/geo.h"

using namespace math;

/* MATH::LINE-IS-COLINEAR
 ******************************************************************/
LineIsColinear::LineIsColinear()
	: mEps(geo::EPS)
{
}

bool LineIsColinear::on(const Segment3& a, const Segment3& b)
{
	return on(a.mPt[0], a.mPt[1], b.mPt[0], b.mPt[1]);
}

bool LineIsColinear::on(	const Point3& a0, const Point3& a1,
							const Point3& b0, const Point3& b1)
{
	return mPL.on(a0, b0, b1, NULL) <= mEps
			&& mPL.on(a1, b0, b1, NULL) <= mEps;
}
