#ifndef LINEISCOLINEAR_H
#define LINEISCOLINEAR_H

#include "math/tests/ptline.h"

namespace math {

/* MATH::LINE-IS-COLINEAR
 * Tests if two 3D lines (or segments) are colinear by verifying that
 * the end points of one are on the other.  This should be an easy check
 * in 2d, but this is the best way I can think to do it in 3d.
 ******************************************************************/
class LineIsColinear
{
public:
	// Precision that determines colinearity.
	double				mEps;

public:
    LineIsColinear();

	bool				on(const Segment3& a, const Segment3& b);
	bool				on(	const Point3& a0, const Point3& a1,
							const Point3& b0, const Point3& b1);

private:
	PtLine				mPL;
};

} // namespace math

#endif // LINEISCOLINEAR_H
