#ifndef LINELINE_H
#define LINELINE_H

#include "math/primitives/segment3.h"

namespace math {

/* MATH::LINE-LINE
 * Distance between two lines (not segments), 3d
 ******************************************************************/
class LineLine
{
public:
	double			mEps;
	Point3			mNearestA, mNearestB;

public:
	LineLine();

	// The nearest points on line 1 and line 2.
	Point3			mNearest1, mNearest2;

	double			on(	const Segment3& L1, const Segment3& L2);
	double			on(	const Point3& a1, const Point3& a2,
						const Point3& b1, const Point3& b2);
	// Yet another algorithm
	bool			on2(const Point3& a1, const Point3& a2,
						const Point3& b1, const Point3& b2);

private:
	Point3			mB2B1, mA1B1, mA2A1,
					mU, mV;

	double			mMua, mMub;

	Point3			m13, m43, m21;
};

} // namespace math

#endif // LINELINE_H
