#include "ptline.h"

using namespace math;

/* MATH::PT-LINE
 ******************************************************************/
PtLine::PtLine()
{
}

double PtLine::on(const Point3& pt, const Segment3& seg, Point3* out)
{
	return on(pt, seg.mPt[0], seg.mPt[1], out);
}

double PtLine::on(const Point3& pt, const Point3& a0, const Point3& a1, Point3* out)
{
	mV.asSub(a1, a0);
	mW.asSub(pt, a0);

	const double		c1 = mW.dot3(mV),
						c2 = mV.dot3(mV);
	const double		b = c1 / c2;

	mV *= b;
	mPb = a0;
	mPb += mV;
	if (out != NULL) out->set(mPb);
	return pt.dist3(mPb);
}
