#ifndef PTLINE_H
#define PTLINE_H

#include "math/primitives/segment3.h"

namespace math {

/* MATH::PT-LINE
 * Distance from point to unbounded line, 3D
 * from http://http://www.softsurfer.com/Archive/algorithm_0102/
 ******************************************************************/
class PtLine
{
public:
    PtLine();

	double		on(const Point3& pt, const Segment3& seg, Point3* out = NULL);
	double		on(const Point3& pt, const Point3& a0, const Point3& a1, Point3* out = NULL);

private:
	Point3		mV, mW, mPb;
};

} // namespace math

#endif // PTLINE_H
