#ifndef PTSEG_H
#define PTSEG_H

#include "math/primitives/point3.h"

namespace math {

/* MATH::PT-SEG
 * Distance from point to line segment, 3D
 * from http://www.softsurfer.com/Archive/algorithm_0102/#dist_Point_to_Segment()
 ******************************************************************/
class PtSeg
{
public:
	// If an out point isn't supplied, then the hit will be placed here.
	Point3		mHit;

public:
    PtSeg();

	double		on(	const Point3& pt, const Point3& a0, const Point3& a1);
	double		on(	const Point3& pt, const Point3& a0, const Point3& a1,
					Point3& out);
	double		onSquared(	const Point3& pt, const Point3& a0, const Point3& a1);
	double		onSquared(	const Point3& pt, const Point3& a0, const Point3& a1,
							Point3& out);

private:
	Point3		mV, mW, mPb;
};

} // namespace math

#endif // PTSEG_H
