#include "pttopoly.h"

#include <math.h>

using namespace math;

/* MATH::PT-TO-POLY
 ******************************************************************/
PtToPoly::PtToPoly()
{
}

double PtToPoly::on(const Point3& pt, const Polygon& p)
{
	return sqrt(onSquared(pt, p));
}

double PtToPoly::onSquared(const Point3& pt, const Polygon& p)
{
	const qint32			size = p.getSize();
	if (size < 1) return 0;		// ERROR, actually
	const Point3*			pts = p.getPoints();
	const Point3*			prv = &pts[size-1];
	double					min = pt.dist3Squared(*prv);
	for (qint32 k=0; k<size; k++) {
		const Point3&		nxt = pts[k];
		const double		d = mPS.onSquared(pt, *prv, nxt);
		if (d < min) min = d;
		prv = &nxt;
	}
	return min;
}
