#ifndef SEGINTERSECTION_H
#define SEGINTERSECTION_H

#include "math/primitives/point3.h"
#include "math/tests/ptseg.h"

namespace math {

/* MATH::SEG-INTERSECTION
 * Find the intersection between two segments, if any.
 ******************************************************************/
class SegIntersection
{
public:
	static const int		ERROR = -1;
	static const int		INTERSECTS = 0;

public:
	double					mEps;

public:
	SegIntersection();

	int						on(const Point3& a0, const Point3& a1,
							   const Point3& b0, const Point3& b1,
							   Point3& out0, Point3& out1);

private:
	Point3					mHit[4];
	double					mD[4];
	int						mNearest[2];

	PtSeg					mPS;

	void					addNearest(const int idx);
};

} // namespace math

#endif // SEGINTERSECTION_H
