#include "segpoly.h"

using namespace math;

/* MATH::SEG-POLY
 ******************************************************************/
SegPoly::SegPoly()
	: mEps(0.01)
{
}

bool SegPoly::on(	const Point3& a0, const Point3& a1,
					const Polygon& b)
{
	const qint32			size = b.getSize();
	const Point3*			pts = b.getPoints();
	const Point3*			prv = &(pts[size-1]);
	bool					first = true;
	for (qint32 k=0; k<size; k++) {
		const Point3&		nxt = pts[k];
		if (mSS.on2(a0, a1, *prv, nxt) && (first || mSS.mDistanceToHit < mDistanceToHit)) {
			first = false;
			mDistanceToHit = mSS.mDistanceToHit;
			mHit.set(mSS.mHit);
		}
		prv = &nxt;
	}
	return !first;
}
