#ifndef SEGPOLY_H
#define SEGPOLY_H

#include "math/primitives/polygon.h"
#include "math/tests/segseg.h"

namespace math {

/* MATH::SEG-POLY
 * Distance from seg to poly.
 ******************************************************************/
class SegPoly
{
public:
	double				mEps;				// Precision
	double				mDistanceToHit;		// On success
	Point3				mHit;				// Intersection point on success

public:
    SegPoly();

	bool				on(	const Point3& a0, const Point3& a1,
							const Polygon&);

private:
	SegSeg				mSS;

	Point3				mPt;
};

} // namespace math

#endif // SEGPOLY_H
