#ifndef SEGSEG_H
#define SEGSEG_H

#include "math/tests/lineline.h"
#include "math/tests/ptseg.h"

namespace math {

/* MATH::SEG-SEG
 * Find the nearest intersection between two 3D segments.
 * From softsurfer
 * http://softsurfer.com/Archive/algorithm_0106/algorithm_0106.htm#dist3D_Segment_to_Segment()
 ******************************************************************/
class SegSeg
{
public:
	double				mEps;				// Precision
	double				mDistanceToHit;		// On success
	Point3				mHit;				// Things are confused right now,
											// this is only valid for on2()

public:
	SegSeg();

	bool				on(const Segment3& a, const Segment3& b,
							Point3* nearest = NULL);
	bool				on(	const Point3& a0, const Point3& a1,
							const Point3& b0, const Point3& b1,
							Point3* nearest = NULL);
	bool				on2(const Point3& a0, const Point3& a1,
							const Point3& b0, const Point3& b1);

private:
//	Point3				mU, mV, mW, mY, mDp;

	math::LineLine		mLL;
	math::PtSeg			mPS;
};

} // math

#endif // SEGSEG_H
