#ifndef CONTEXT_H
#define CONTEXT_H

#include "engine/fxdefs.h"
#include "param/param.h"
#include "engine/colorsrchead.h"

class ArcHead;

/* CONTEXT
 * Provide environmental info related
 * to a project.
 ********************************************/
class Context : public fx::Setup
{
public:
	// PROJECT behaviour
	// Answer true if I have the item identified by the url
	virtual bool			contains(const param::Url&) const = 0;

	virtual void			getParams(param::List&, param::GetArgs&) const = 0;
	virtual void			setParamF(const param::Url&, const float) = 0;
	virtual void			setParamStr(const param::Url&, const QString&) = 0;
	virtual void			setParamArc(const param::Url&, const ArcHead&) = 0;
	virtual void			setParamClr(const param::Url&, const ColorSrcHead&) = 0;
	virtual void			setFlag(const param::Url&, const int bit, const bool on) = 0;

protected:
	Context()				{ }
	virtual ~Context()		{ }
};

#endif // CONTEXT_H
