#ifndef EXPORTDIALOG_H
#define EXPORTDIALOG_H

#include <QDialog>
#include <QMenu>
#include "model/exportlist.h"
class ActiveProject;
class QLineEdit;
class QPushButton;

/* EXPORT-DIALOG
 * Configure and export the rendered image.
 ******************************************************************/
class ExportDialog : public QDialog
{
	Q_OBJECT

public:
	ExportDialog(ActiveProject&, QWidget * parent = 0);

public slots:
	void				onRequestFilename();
	virtual void		accept();

private:
	ActiveProject&		mPrj;
	ExportList			mExports;
	int					mCur;

	const QSize			mCanvasSize;
	QSize				mPercentSize;
	QSize				mPixelSize;

	// UI caching
	QMenu				mScaleMenu;
	QPushButton*		mFile;
	QPushButton*		mScale;
	QLineEdit*			mW;
	QLineEdit*			mH;

	void				pushModelToUi();
};

#endif // EXPORTDIALOG_H
