#ifndef FRAMECONTROL_H
#define FRAMECONTROL_H

#include <QFrame>
#include "model/activeproject.h"
#include "ui/look.h"
#include "ui/rawcontrol.h"

/* FRAME-CONTROL
 * For manipulating the Frame group parameters.
 ******************************************************************/
class FrameControl : public RawControl
{
public:
	explicit FrameControl(QWidget& parent, ActiveProject&, const Look&);

	virtual void			clear();
	virtual void			setTo(const param::List& list);

	virtual bool			mousePressEvent(QMouseEvent*);
	virtual void			mouseMoveEvent(QMouseEvent*);
	virtual void			mouseReleaseEvent(QMouseEvent*);
	virtual void			onPaint(QPainter&);

private:
	QWidget&				mParent;
	ActiveProject&			mPrj;
	const Look&				mLook;
	QRectF					mFrame;
	param::Url				mUrlL, mUrlT, mUrlR, mUrlB;

	int						mDownMask;
	QRectF					mDownFrame;
	QPointF					mDownPt;
	float					mDownRatio;
};

#endif // FRAMECONTROL_H
