#ifndef NAVIGATION_H
#define NAVIGATION_H

#include<QObject>
#include <QPoint>

/* NAVIGATION
 * The API for controlling the state of
 * window elements -- what's selected,
 * what modes are active.
 ********************************************/
class Navigation : public QObject
{
	Q_OBJECT
public:
	Navigation(QObject *parent = 0);

	// HACK!
	int				mSelectedFx;

	void			addFx(const QPoint pos);
	void			removeFx(const int fxId);
	void			selectFx(const int fxId);

	void			command(const QString&);
	void			loadProject();
	void			saveProject();

signals:
	void			onAddFx(const QPoint pos);
	void			onRemoveFx(const int fxId);
	void			onSelectFx(const int fxId);

	void			onCommand(const QString);
	void			onLoadProject();
	void			onSaveProject();
};

#endif // NAVIGATION_H
