#ifndef RAWCONTROL_H
#define RAWCONTROL_H

#include <QPainter>
#include "param/paramlist.h"
class QMouseEvent;

/* RAW-CONTROL
 * A first pass at controls that sit on the render view, allowing
 * direct manipulation of params.  This is being designed solely
 * for setting the frame shape; not sure what other uses will appear.
 ******************************************************************/
class RawControl
{
public:
	virtual ~RawControl();

	bool					isEnabled() const;

	virtual void			clear();
	virtual void			setTo(const param::List& list) = 0;

	virtual bool			mousePressEvent(QMouseEvent*) = 0;
	virtual void			mouseMoveEvent(QMouseEvent*) = 0;
	virtual void			mouseReleaseEvent(QMouseEvent*) = 0;
	virtual void			onPaint(QPainter&) = 0;

protected:
	RawControl();
	bool					mEnabled;
};

#endif // RAWCONTROL_H
