#ifndef SETTINGSPLUG_H
#define SETTINGSPLUG_H

#include <QPixmap>

#include "engine/fxui.h"

class ActiveProject;
class Navigation;

/* SETTINGS-PLUG
 * Display the global project settings / tools.  (file IO, etc.)
 ******************************************************************/
class SettingsPlug : public FxUi
{
public:
	SettingsPlug(ActiveProject&, Navigation&, QWidget* parent);
	virtual ~SettingsPlug();

	virtual void				setParent(FxUi::Parent*, const Look&);
	virtual int					onProjectChanged();

private:
	typedef FxUi				inherited;
	ActiveProject&				mPrj;
	Navigation&					mNav;
	QWidget*					mQParent;
	bool						mNeedsCache;

	/* FX-E.  One FX entry.
	 **************************************************************/
	class FxE : public FxUi::Entry {
	public:
		FxE(SettingsPlug&, const QString& label);

		virtual QSize			size() const;
		virtual void			onPaint(paint_args&);
		virtual void			mousePressEvent(const mouse_args& down);
		virtual void			mouseMoveEvent(const mouse_args& down);
		virtual void			mouseReleaseEvent(const mouse_args& down);

		void					cache(const int entryH, const Look&);

	private:
		SettingsPlug&			mPlug;
		const QString			mLabel;
		QPixmap					mImg;
	};
	QList<FxE*>					mE;

	void						cache(const int entryH, const Look&);
	void						uncache();
};

#endif // SETTINGSPLUG_H
