#include "sizedialog.h"

#include <QDebug>
#include <QLineEdit>
#include <QGridLayout>
#include <QLabel>
#include <QPushButton>

/* SIZE-DIALOG
 ******************************************************************/
SizeDialog::SizeDialog(const QSize& canvasSize, QWidget * parent)
	: QDialog(parent)
	, mWidth(NULL)
	, mHeight(NULL)
{
	setSizeGripEnabled(false);

	QGridLayout*		layout = new QGridLayout;
	QLabel*				label;
	QLineEdit*			edit;
	QPushButton*		push;

	QString				wstr, hstr;
	wstr = QString("%1").arg(canvasSize.width());
	hstr = QString("%1").arg(canvasSize.height());

	if ((label = new QLabel("width")) != NULL) layout->addWidget(label, 0, 0);
	if ((edit = new QLineEdit(wstr)) != NULL) {
		mWidth = edit;
		layout->addWidget(edit, 0, 1);
	}
	if ((label = new QLabel("height")) != NULL) layout->addWidget(label, 1, 0);
	if ((edit = new QLineEdit(hstr)) != NULL) {
		mHeight = edit;
		layout->addWidget(edit, 1, 1);
	}
	if ((push = new QPushButton("Ok")) != NULL) {
		QObject::connect(push, SIGNAL(clicked()), this, SLOT(accept()));
		layout->addWidget(push, 2, 0);
	}
	if ((push = new QPushButton("Cancel")) != NULL) {
		QObject::connect(push, SIGNAL(clicked()), this, SLOT(reject()));
		layout->addWidget(push, 2, 1);
	}
	setLayout(layout);
}

bool SizeDialog::getSize(QSize& size) const
{
	if (mWidth == NULL || mHeight == NULL) return false;

	bool				okW, okH;
	int					w, h;
	w = mWidth->displayText().toInt(&okW);
	h = mHeight->displayText().toInt(&okH);
	if (!okW || !okH) return false;

	size = QSize(w, h);
	return true;
}
