#include "valuepopup.h"

#include <QPainter>

/* VALUE-POPUP
 ******************************************************************/
ValuePopup::ValuePopup(const Look& look, QWidget *parent)
	: QWidget(parent, Qt::Popup)
	, mLook(look)
{
}

ValuePopup::~ValuePopup()
{
}

QSize ValuePopup::minimumSizeHint() const
{
	return QSize(40, 40);
}

QSize ValuePopup::sizeHint() const
{
	return QSize(40, 40);
}

void ValuePopup::popup(QWidget* parent)
{
	mPopupParent = parent;
	show();
}

void ValuePopup::paintEvent(QPaintEvent*)
{
	QPainter painter(this);
	painter.setPen(Qt::NoPen);
	painter.setBrush(mLook.mParamBgToneB);
	painter.drawRoundedRect(0, 0, 20, 20, 5, 5);
}

/* VALUE-POPUP-BUTTON
 ******************************************************************/
ValuePopupButton::ValuePopupButton(const Look& look, QWidget *parent)
	: QWidget(parent)
	, mLook(look)
{
	mPopup = new ValuePopup(mLook, this);
}

ValuePopupButton::~ValuePopupButton()
{
}

QSize ValuePopupButton::minimumSizeHint() const
{
	return QSize(40, 40);
}

QSize ValuePopupButton::sizeHint() const
{
	return QSize(40, 40);
}

void ValuePopupButton::mousePressEvent(QMouseEvent*)
{
	if (mPopup != NULL) mPopup->popup(this);
}

void ValuePopupButton::paintEvent(QPaintEvent*)
{
	QPainter painter(this);
	painter.setPen(Qt::NoPen);
	painter.setBrush(mLook.mParamBgToneB);
	painter.drawRoundedRect(0, 0, 20, 20, 5, 5);
}
