#ifndef VALUEPOPUP_H
#define VALUEPOPUP_H

#include <QWidget>
#include "look.h"

/* VALUE-POPUP
 * Popup widget for setting a single value.
 ******************************************************************/
class ValuePopup : public QWidget
{
	Q_OBJECT

public:
	ValuePopup(const Look&, QWidget *parent = 0);
	~ValuePopup();

	QSize					minimumSizeHint() const;
	QSize					sizeHint() const;

	void					popup(QWidget* parent);

protected:
	void					paintEvent(QPaintEvent *event);

private:
	const Look&				mLook;
	QWidget*				mPopupParent;
};

/* VALUE-POPUP-BUTTON
 * Button that opens a value popup, probably won't be necessary.
 ******************************************************************/
class ValuePopupButton : public QWidget
{
	Q_OBJECT

public:
	ValuePopupButton(const Look&, QWidget *parent = 0);
	~ValuePopupButton();

	QSize					minimumSizeHint() const;
	QSize					sizeHint() const;

protected:
	void					mousePressEvent(QMouseEvent*);
	void					paintEvent(QPaintEvent *event);

private:
	const Look&				mLook;
	ValuePopup*				mPopup;
};

#endif // VALUEPOPUP_H
